!ABCIncludeFile

OMIT('_EndOfInclude_',_FldMgrClPresent_)
_FldMgrClPresent_ EQUATE(1)

!Other Classes
   Include('ABFILE.INC')

!Equates - will be seen by using program
FieldListQtype  Queue,Type
FieldName   string(20)
FieldRef    Any
  End

KeyQtype    Queue,type
KeyName     string(80)
TheKey      &key
   end


FldMgrClType Class,type,module('FldMgrCl.CLW'),LINK('FldMgrCl.CLW',_ABCLinkMode_),DLL(_ABCDllMode_)

!Member Data
FieldListQ      &FieldListQType     !List of fields, with ref var for each
KeyQ            &KeyQType           !List of Keys for the file
File            &File               !reference to the file variable
Buffer          &Group              !reference to the file buffer
FM              &FileManager        !Reference to the filemanager class
RM              &RelationManager    !Reference to the Relation Manager class

!Set up Methods - Calls are template generated
Init                Procedure()
Kill                Procedure()
AddFile             Procedure(File pFile, *Group pBuffer)
AddManagers         Procedure(FileManager pFM, RelationManager pRM)
AddKey              Procedure(string pKeyName, Key pKey)
AddField            Procedure(String pFieldName, *? pField)
AliasField          Procedure(String pFieldName, string pAliasName)
AliasKey            Procedure(String pKeyName, String pAliasName)


Insert              Procedure(byte handleErrors=0),byte,proc
Update              Procedure(),byte,proc
Delete              procedure(byte pAskFirst=0),byte,proc
SetField            Procedure(String pFieldName)
SetField            Procedure(String pFieldName, ? pTheValue)
SetField            Procedure(String pFieldName, *Cstring)
GetField            Procedure(String pFieldName),*?
ClearBuffer         Procedure()
Fetch               Procedure(string pKeyName),byte,proc
SetFile             Procedure(),byte,proc
SetKey              Procedure(String pKeyName,<String pKeyName2>),byte,proc
Next                procedure(),byte,proc
Previous            Procedure(),Byte,proc
  End
 !_EndOfInclude_